=== packaging/debian/control ===
Source: gammu
Section: comm
Priority: optional
Maintainer: Michal Cihar <michal@cihar.com>
Build-Depends: debhelper (>= 4.0.0), libc6-dev, libbluetooth1, libbluetooth1-dev, autoconf
Standards-Version: 3.6.0

Package: gammu
Architecture: any
Depends: ${shlibs:Depends}
Suggests: wammu
Description: Mobile phone management utility
 Gammu (Gammu All Mobile Management Utility) is program to manage mobile phone.
 .
 Gammu can do such things with cellular phones as making data calls,
 updating the address book, changing calendar and ToDo entries, sending and
 receiving SMS messages, loading and getting ring tones and pictures (different
 types of logos), synchronizing time, enabling NetMonitor, managing WAP
 settings and bookmarks and much more. Functions depend on the phone model.
 .
 Currently supported phones are:
 .
  * Many Nokia phones.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * Any AT capable phone (Siemens, Nokia, Alcatel, IPAQ).
 .
 This package contains gammu binary.

Package: libgammu1-dev
Replaces: libgammu-dev
Conflicts: libgammu-dev, libgammu
Section: libdevel
Architecture: any
Depends: libgammu1 (= ${Source-Version})
Description: Header files for Gammu
 Gammu (Gammu All Mobile Management Utility) is program to manage mobile phone.
 .
 Gammu can do such things with cellular phones as making data calls,
 updating the address book, changing calendar and ToDo entries, sending and
 receiving SMS messages, loading and getting ring tones and pictures (different
 types of logos), synchronizing time, enabling NetMonitor, managing WAP
 settings and bookmarks and much more. Functions depend on the phone model.
 .
 Currently supported phones are:
 .
  * Many Nokia phones.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * Any AT capable phone (Siemens, Nokia, Alcatel, IPAQ).
 .
 This package contains header files needed for compiling programs with Gammu.

Package: libgammu1
Replaces: libgammu
Conflicts: libgammu
Suggests: gammu
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description:  Mobile phone management library
 Gammu (Gammu All Mobile Management Utility) is program to manage mobile phone.
 .
 Gammu can do such things with cellular phones as making data calls,
 updating the address book, changing calendar and ToDo entries, sending and
 receiving SMS messages, loading and getting ring tones and pictures (different
 types of logos), synchronizing time, enabling NetMonitor, managing WAP
 settings and bookmarks and much more. Functions depend on the phone model.
 .
 Currently supported phones are:
 .
  * Many Nokia phones.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * Any AT capable phone (Siemens, Nokia, Alcatel, IPAQ).
 .
 This package contains Gammu library.
